ISIS - Bug #2244

Pixel (Line/Sample) Projection Offset Issue
2015-04-27 11:07 AM - Tammy Becker

Status: In Progress

Priority: High

Assignee: Stuart Sides

Category: Applications

Target version: FY17 Sprint 3

Impact: Software Version: 3.4.10 (FY15 R3 2015-07-23 Jul)
Description

The purpose of this ticket is to centralize information regarding the ISIS Pixel Projection Offset issue when importing and exporting

maps (e.g., DEMs, Mosaic Maps, etc).

Tickets for modifying specific ISIS applications regarding this offset issue should be "related" to this main ticket for context and

tracking.

The crux of the matter is how ISIS references the coordinate system of an imported digital map, particularly the "upper left pixel".
The coordinate system reference is applied upon import (pds2isis) and export (isis2pds) and depends on the definition of the source

product (i.e., The pixel offset definition differences between ISIS and PDS).

Additional coordinate system details are the latitude system, radius (especially triaxial), and longitude direction.

"Watchers" of this post are initially based on previous and current involvement/interest.

Subtasks:
Bug # 4530: Pixel Offset - isis2pds
Documentation # 4547: documentation for pds2isis

Acknowledge
Acknowledge:

|

Related issues:

Related to ISIS - Bug #748: map2map failing for Oblique Cylindrical level 2 E...
Related to ISIS - Feature #1919: Create new program to ingest Kaguya MI MAP f...
Related to ISIS - Bug #1012: The line,sample projection offset values output ...
Related to ISIS - Feature #872: Create an isis2pds like - Cassini Radar speci...
Related to ISIS - UserTestPlan #4503: pds2isis - Pixel (Line/Sample) Projecti...
Related to ISIS - UserTestPlan #4504: isis2pds - Pixel (Line/Sample) Projecti...
Related to ISIS - UserTestPlan #4505: mimap2isis - Import PDS formatted Kaguy...
Related to ISIS - Feature #2358: ISIS capability to work with Kaguya MI L3C5 ...
Related to ISIS - UserTestPlan #4507: mrf2isis - Import PDS formatted MiniRF ...
Related to ISIS - UserTestPlan #4513: hirdr2isis - Ingestion of a hirise RDR ...
Related to ISIS - UserTestPlan #4514: hirdrgen - Convert HiRISE RDR cubes int...
Related to ISIS - UserTestPlan #4515: hidtmgen - Generates PDS products from ...
Related to ISIS - UserTestPlan #4516: glinims2isis - Import archived Galileo ...
Related to ISIS - UserTestPlan #4517: hrsc2isis - Import Mars Express HRSC fi...
Related to ISIS - UserTestPlan #4518: crism2isis - Import Crism PDS products ...

Assigned
Closed 2013-11-25
Closed

In Progress
Resolved
Resolved
Feedback
Feedback
New

New

New

New

New

New

New

History

#1 - 2015-04-27 11:07 AM - Tammy Becker
- Related to Bug #748: map2map failing for Oblique Cylindrical level 2 Enceladus files added

#2 - 2015-04-27 11:10 AM - Tammy Becker
- Related to Feature #1919: Create new program to ingest Kaguya M| MAP files into ISIS added

#3 - 2015-04-27 11:10 AM - Tammy Becker

- Related to Bug #1012: The line,sample projection offset values output by ISIS to PDS files is incorrect added
#4 - 2015-04-27 11:10 AM - Tammy Becker
- Related to Feature #872: Create an isis2pds like - Cassini Radar specific PDS output application added

#5 - 2015-04-27 11:15 AM - Tammy Becker
Brent Archinal's email (April 26, 2015) following a meeting with TU Berlin [E. Tasdelen and K. Willner].

"l would suggest the steps to be considered/taken in the long run are:

1. Documentation (investigation and addition to ISIS documentation) 1a) How does ISIS handle each data set on input? 1b) How does ISIS handle
each data set on output?

(Jeff Anderson's e-mail of 2011 January 27 says the input calculations are described in
$ISIS3DATA/base/translations/pdsProjectionLineSampToXY.def, but there may be other locations as well. | assume that file is used by PDS2ISIS
style programs, but what about input of DEMs or other files?)

1. Investigation/decisions
2a) Are the datasets being handled correctly on input?
2b) Is ISIS "doing the right thing" internally, i.e. to make products.
2c) Should datasets be handled the same way on output as on input (probably)?

2. Software changes, based on step 2 (if any).
3a) Change input steps as necessary.
3b) Other ISIS changes as necessary so it does the right thing internally.
3c) Change output steps to match input steps (presumably).
3d) Update documentation (being careful to save the old documentation on what ISIS previously did, somehow)

3. Optional: Create a white paper or some other publication(s) describing the issue and how it's handled for both PDS 3 and 4, and for GDAL.
4a) Distribute appropriately, e.g. ISIS documentation; publication; distribution to PDS personnel, GDAL author(s)

#6 - 2015-04-27 11:16 AM - Tammy Becker
Trent Hare's email [April 27, 2015]:

Just FYI - submit update to GDAL to fix PDS offset ingest bug.
https://trac.osgeo.org/gdal/ticket/5941

Please check. | can update if you find anything incorrect.

To correct in ISIS the file
$ISIS3DATA/base/translations/pdsProjectionLineSampToXY.def

These lines should be changed to
# STANDARD PDS

2017-01-01 2/10


https://trac.osgeo.org/gdal/ticket/5941

# Should always be last

Group = Selection

Keyword = "PDS_VERSION_ID"
Pattern = "PDS3"

xMult =-1.0
yMult =1.0
xOff =0.5
yOff =0.5
End_Group

And | think this line for MOLA should be added

Group = Selection
Keyword = "DATA_SET_ID"
Pattern = "MGS-M-MOLA-5-MEGDR-L3-V1.0"

xMult =-1.0
yMult =1.0
xOff =-0.5
yOff =-0.5
End_Group

#7 - 2015-04-28 09:45 AM - Stuart Sides
- Category set to Applications

#8 - 2015-04-28 09:46 AM - Trent Hare

If the defaults are truly deemed incorrect (all signs to point to that from multiple avenues), then we will need to also fix the source code defaults.

from: http://isis.astrogeology.usgs.gov/Object/Programmer/_process_import_pds_8cpp_source.html

01424 void ProcessimportPds::GetProjectionOffsetMults(double &xoff, double &yoff,
01425 double &xmult, double &ymult) {

01426

01427 xmult = -1.0;

01428 ymult=1.0;

01429  xoff = -0.5;

01430 yoff = -0.5;

patched to

01429  xoff = 0.5;
01430 yoff = 0.5;
#9 - 2015-04-28 04:14 PM - Trent Hare

If we are really going to do this on import (if proven correct) then exporting will need to also be updated.
http://isis.astrogeology.usgs.gov/Object/Programmer/_process_export_pds_8cpp_source.html

from:
00776 lineOffset += 0.5; // Add half a line to get to the center of (1,1)
00781 sampleOffset += 0.5; / Add half a sample to get to the center of (1,1)

to

00776 lineOffset -= 0.5; // Subtract half a line to get to the center of (1,1)
00781 sampleOffset -= 0.5; // Subtract half a sample to get to the center of (1,1)

A great test image is LOLA DEM since it is so small, simple and global 1440x720

PDS image: http://pds-geosciences.wustl.edu/Iro/Iro-I-lola-3-rdr-v1/Irolol_1xxx/data/lola_gdr/cylindrical/img/ldem_4.img
detached label: http://pds-geosciences.wustl.edu/Iro/Iro-I-lola-3-rdr-vi/Irolol_1xxx/data/lola_gdr/cylindrical/img/ldem_4.lbl
parent link: http://pds-geosciences.wustl.edu/missions/Iro/lola.htm

Currently it does appear ISIS is exporting to PDS files one pixel off.

-Trent

#10 - 2015-12-04 01:42 PM - Christopher Isbell

I'll start by showing some basic testing results, toward confirming the "one pixel off" issue as known prior and discussed in this thread. Then, will
follow with additional detail. (I plan to "submit" at stages throughout this session, so watchers will likely see multiple updates).

First, a few (mostly known) points (corrections welcome):

Assumptions/conclusions:

isis2pds creates output PDS3 files containing incorrect line
sample_projection_offset values (off by one for each axis), intended to be
offsets relative to +center+ (per PDS3 and ISIS2 definitions) +of pixel 1,1+.

#* And, considering ingest of such files (per definition file):

# The defaults used in ProcessimportPds are:
# xMult = -1.0
# yMult = 1.0
# xOff =-05
# yoOff = -0.5

#* Therefore, a PDS3 labeled file with incorrect offset values will be adjusted (correctly, for UpperLeftCornerX/Y values) at ingest via pds2isis (good).

+However+, if a mission/project produces PDS3 files containing +correct+
offsets, pdsZ2isis (without a relevant definition file entry) will introduce an
"error"” (to UpperLeftCornerX/Y values) at ingest.

#* Of course, +if+ we know this, we can define appropriate scalar/translation values (per subject) via the definition file.

Now, a "simple"” 1ppd case via ISIS3 (360 samples x 180 lines) ...

#* isis2pds output (global equi/simp/sinu):

OBJECT = IMAGE

LINES - 180
LINE_SAMPLES - 360
CENTER_LONGITUDE = 180.0
MAP_RESOLUTION -1.0
MAXIMUM_LATITUDE =900
MINIMUM LATITUDE ~ =-90.0

EASTERNMOST_LONGITUDE =360.0
WESTERNMOST_LONGITUDE =0.0
LINE_PROJECTION_OFFSET = 90.499999999998
SAMPLE_PROJECTION_OFFSET = 180.5

#* And, according to PDS3 and ISIS2 definitions:
(from equator/180 longitude origin)

line offset should be [(90x1) - 0.5] = 89.5
sample offset should be [(180x1) - 0.5] = 179.5

#* So, yes, isis2pds offset values are incorrect (by one pixel, significant at low res, less significant at higher res).

And, a slightly less simple case ...

#* isis2pds output (equirectangular clat=0, = simple cylindrical)
OBJECT = IMAGE

LINES = 7666

LINE_SAMPLES = 15331

OBJECT = IMAGE_MAP_PROJECTION

i\-/iAP_PROJECTION_TYPE = "EQUIRECTANGULAR"

CENTER_LATITUDE =0.0
CENTER_LONGITUDE =180.0
MAP_RESOLUTION = 42.586033748662
MAP_SCALE =1.0
MAXIMUM_LATITUDE =90.0
MINIMUM_LATITUDE =-90.0

EASTERNMOST_LONGITUDE =360.0
WESTERNMOST_LONGITUDE =0.0
LINE_PROJECTION_OFFSET =3833.5
SAMPLE_PROJECTION_OFFSET = 7666.5

#* Per definitions:

(from equator/180 longitude origin)

line offset should be [nint( 90 x 42.586033748662) - 0.5] = 3832.5

sample offset should be [nint(180 x 42.586033748662) - 0.5] = 7664.5 ?
.or?..

sample offset should be [round up(180 x 42.586033748662) - 0.5] = 7665.5
(re "extra" sample (or line) above, and "final details" below)

#** Again, isis2pds offset values are off by one pixel.

Along with, a Polar Stereographic case ...
OBJECT = IMAGE
LINES =3078
LINE_SAMPLES =3078

6BJ ECT = IMAGE_MAP_PROJECTION

MAP_PROJECTION_TYPE ="POLAR STEREOGRAPHIC"
CENTER_LATITUDE =90.0

CENTER_LONGITUDE =0.0

MAP_RESOLUTION = 42.586033748662

MAP_SCALE =1.0

MAXIMUM_LATITUDE =90.0

MINIMUM_LATITUDE =55.0

EASTERNMOST_LONGITUDE =360.0
WESTERNMOST_LONGITUDE =0.0
LINE_PROJECTION_OFFSET = 1539.5
SAMPLE_PROJECTION_OFFSET = 1539.5

(from pole origin)
line offset should be [ (3078/2) - 0.5] = 1538.5
sample offset should be [ (3078/2) - 0.5] = 1538.5

+Summary (current ISIS3 function)+. Again, most of this is already known by others. Per other project work and cartographic interest, and as
requested, I've provided related testing/confirmation and additional input and background here. | hope this is helpful.

* jsis2pds creates output PDSS files containing incorrect projection_offset values.

* An isis2pds generated PDS3 labeled file (thus, reflecting incorrect offset values) will be corrected at ISIS3 ingest via pds2isis.

* An ISIS3 ingest via pds2isis will adjust projection_offset values according to relevant entries (if they exist) within the ProcessimportPds definition file.
* +Any other+ file ingested via pds2isis will have projection offset values adjusted by default definition values (see item 1. above).

** That is, a pds2isis input file containing "correct" projection offset values will have offset values adjusted (by default) at ingest (resulting in incorrect
ISIS3 UpperLeftCornerX/Y values).

+Some final details+

* This issue/problem becomes more complex when ...

** Due to "round-off" and/or other cartographic calculations, a resulting image array contains an extra line and/or sample (e.g. 361x181 vs 360x180,
and re item 4. above).

** ..., thus uncertainty on the precise location of projection origin within a specific pixel, etc.

** And other complexities I'm sure.
#11 - 2016-01-27 03:28 PM - Christopher Isbell
Although "Updated by" date did not change, there has been lengthy recent addition to "C Isbell" item (#10) above. Thanks, Chris

#12 - 2016-01-28 09:03 AM - Christopher Isbell

Comments/Questions/Conclusions:

Based on ticket history here, and discussions with others, it appears this is the summary of what should be done regarding ISIS export and import.
Comments/correction welcome. And, | assume such decisions/actions would come following final discussions among
management/developers/stakeholders (most "Watchers" here):

* For export, make changes to code/config files such that isis2pds produces correct offset values (re THare item#9 above).

* For import, make changes to code/config files such that, +by default+, pds2isis applies +no correction+ (i.e. scalar=1.0, translation=0.0) to input file
projection offset values ...

** .. +except+ where ProcessImportPds content defines otherwise per +specific+ products/datasets.

** This means there should be no default values (as there is now) within ProcessimportPds.

** Therefore, ProcessImportPds (and other code/config files?) would need to be updated to contain entries for +ALL+ known products/datasets
previously produced with "incorrect" offset values. (True?)

Finally, a current project example:

** We plan to produce MESSENGER MDIS PDS3 archive products containing correct projection offset values.

** Currently, a pds2isis import of those products would result in incorrect ISIS3 UpperLeftCornerX/Y values.

** With changes discussed/proposed here, these MDIS products (or any other "correct" products) would be ingested within ISIS without spurious
offsets applied.

#13 - 2016-02-16 01:06 PM - Christopher Isbell
Important Update!

Re per #12 content above:

e For import, make changes to code/config files such that, +by default+, pds2isis applies +no correction+ (i.e. scalar=1.0, translation=0.0) to input
file projection offset values ...

Note: This statement is +NOT+ universally accurate regarding scalar & translation values. See KBecker/Clsbell per recent MESSENGER-MIDS
implementation/testing.

#14 - 2016-02-22 06:17 PM - Trent Hare
- Tracker changed from Bug to Recommendation
- Status changed from Acknowledged to Feedback

didn't mean to changed from Bug to Recommendation

#15 - 2016-02-22 06:19 PM - Trent Hare

- Tracker changed from Recommendation to Bug
| agree with the steps that Chris proposed above in #12.

For further background and clarification into the subject, here is a LPSC abstract also:
http://www.hou.usra.edu/meetings/lpsc2016/pdf/1812.pdf

| was worried about ISIS2 cubes, which are also converted to ISIS3 using pds2isis, but an update in the translation table was applied in 2008 which
appears to have it correctly mapped.

-Trent

#16 - 2016-02-23 09:50 AM - Trent Hare
- Software Version set to 3.4.10 (FY15 R3 2015-07-23 Jul)

Just for documenting, Kris added local support for the forthcoming Messenger DEM PDS archive and HRSC PDS archive. This is not a fix just a
work-around for these two data sets.

So within.
$ISIS3DATA/base/translations/pdsProjectionLineSampToXY.def

these two sections were added to support proper registration:

# MESSENGER DEM Products archived in PDS on March, 2016. These products
# have been corrected for the PDS environment such that offsets are correct.

# Therefore, on ingest into ISIS, additional adjustments are required by

# pdsz2isis. The values in the group below will accomodate this condition.

# Products derived by the USGS on 2015-12-02. Contact: Kris J Becker.

Group = Selection

Keyword = "DATA_SET_ID"

Pattern = "MESS-H-MDIS-5-DEM-ELEVATION-V1.0"

xMult =-1.0
yMult =1.0
xOff =0.5
yOff =0.5
End_Group

# HRSC products archived in PDS

Group = Selection

Keyword = "INSTRUMENT_NAME"

Pattern = "HIGH RESOLUTION STEREO CAMERA"

xMult =-1.0
yMult =1.0
xOff =0.5
yOff =0.5
End_Group
#17 - 2016-11-01 10:55 AM - Tammy Becker
- Related to UserTestPlan #4503: pds2isis - Pixel (Line/Sample) Projection Offset Issue added

#18 - 2016-11-01 10:57 AM - Tammy Becker
- Related to UserTestPlan #4504.: isis2pds - Pixel (Line/Sample) Projection Offset Issue added

#19 - 2016-11-01 11:01 AM - Tammy Becker
- Related to UserTestPlan #4505: mimapZ2isis - Import PDS formatted Kaguya Ml MAP file to ISIS3 cube format added

#20 - 2016-11-01 11:03 AM - Tammy Becker
- Related to Feature #2358: ISIS capability to work with Kaguya MI L3C5 data added

#21 - 2016-11-01 11:14 AM - Tammy Becker

- Related to UserTestPlan #4507: mrf2isis - Import PDS formatted MiniRF level1 or level2 image cube into Isis format added

#22 - 2016-11-03 01:53 PM - Tammy Becker
- Related to UserTestPlan #4513: hirdr2isis - Ingestion of a hirise RDR product added

#23 - 2016-11-03 02:01 PM - Tammy Becker
- Related to UserTestPlan #4514: hirdrgen - Convert HIRISE RDR cubes into PDS standard format added

#24 - 2016-11-03 02:12 PM - Tammy Becker
- Related to UserTestPlan #4515: hidtmgen - Generates PDS products from a DMT and/or orthorectified images added

#25 - 2016-11-03 03:22 PM - Tammy Becker
- Related to UserTestPlan #4516: glinimsZ2isis - Import archived Galileo NIMS to ISIS3 added

#26 - 2016-11-03 03:24 PM - Tammy Becker
- Related to UserTestPlan #4517: hrsc2isis - Import Mars Express HRSC files into ISIS added

#27 - 2016-11-03 03:26 PM - Tammy Becker
- Related to UserTestPlan #4518: crism2isis - Import Crism PDS products into I1SIS3 added

#28 - 2016-11-10 10:17 AM - Jason Laura
- Target version set to FY17 Backlog

#29 - 2016-11-10 11:17 AM - Jason Laura
- Status changed from Feedback to Acknowledged

#30 - 2016-11-10 11:31 AM - Jason Laura
- Story points set to 4

DoD for the import version:

* Change 2 lines of code and run the tests

* ldentify what broke

* Research the 'break’ for each to see if you have actually fixed it - this is documentation
* Clean up user test tickets if it did not break anything
#31 - 2016-11-10 11:31 AM - Jason Laura
- Target version changed from FY17 Backlog to FY17 Sprint 3

#32 - 2016-11-16 10:19 AM - Stuart Sides

- Status changed from Acknowledged to In Progress

- Assignee set to Stuart Sides
